## ros-indigo-canopen-chain-node 0.6.9

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(canopen_chain_node)

find_package(catkin REQUIRED
  COMPONENTS
    canopen_master
    diagnostic_updater
    message_generation
    pluginlib
    roscpp
    roslib
    socketcan_interface
    std_msgs
    std_srvs
)

find_package(Boost REQUIRED
  COMPONENTS
    filesystem
)

add_service_files(DIRECTORY srv
                  FILES
                  GetObject.srv
                  SetObject.srv)

generate_messages(DEPENDENCIES)

catkin_package(
  INCLUDE_DIRS
    include
  LIBRARIES
    canopen_ros_chain
  CATKIN_DEPENDS
    canopen_master
    diagnostic_updater
    message_runtime
    pluginlib
    roscpp
    socketcan_interface
    std_srvs
  DEPENDS
    Boost
)

include_directories(
  include
  ${Boost_INCLUDE_DIRS}
  ${catkin_INCLUDE_DIRS}
)

# canopen_ros_chain
add_library(canopen_ros_chain
  src/ros_chain.cpp
)
target_link_libraries(canopen_ros_chain
  ${Boost_LIBRARIES}
  ${catkin_LIBRARIES}
)
add_dependencies(canopen_ros_chain
  ${catkin_EXPORTED_TARGETS}
  ${${PROJECT_NAME}_EXPORTED_TARGETS}
)

# canopen_chain_node
add_executable(canopen_chain_node
  src/chain_node.cpp
)
target_link_libraries(canopen_chain_node
  canopen_ros_chain
  ${Boost_LIBRARIES}
  ${catkin_LIBRARIES}
)

# canopen_sync_node
add_executable(canopen_sync_node
  src/sync_node.cpp
)
target_link_libraries(canopen_sync_node
  ${Boost_LIBRARIES}
  ${catkin_LIBRARIES}
)

install(
  TARGETS
    canopen_chain_node
    canopen_ros_chain
    canopen_sync_node
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(
  DIRECTORY
    include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  FILES_MATCHING PATTERN "*.h"
)

install(
  DIRECTORY
    launch
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

=== debian/changelog ===
ros-indigo-canopen-chain-node (0.6.9-0trusty) trusty; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Tue, 22 May 2018 22:00:00 -0000

ros-indigo-canopen-chain-node (0.6.8-0trusty) trusty; urgency=high

  * added reset_errors_before_recover option
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Mon, 17 Jul 2017 22:00:00 -0000

ros-indigo-canopen-chain-node (0.6.7-0trusty) trusty; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Mon, 27 Mar 2017 22:00:00 -0000

ros-indigo-canopen-chain-node (0.6.6-0trusty) trusty; urgency=high

  * refactored EMCY handling into separate layer
  * do not reset thread for recover
  * properly stop run thread if init failed
  * Merge pull request #201 <https://github.com/ros-industrial/ros_canopen/issues/201> from ipa-mdl/bcm-sync
    Added support for external sync providers
  * deprecation warning for SHM-based master implementations
  * implemented canopen_sync_node
  * added object access services
  * implement level-based object logging
  * added node name lookup
  * wait only if sync is disabled
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Fri, 17 Mar 2017 23:00:00 -0000

ros-indigo-canopen-chain-node (0.6.5-0trusty) trusty; urgency=high

  * protect MotorChain setup with RosChain lock
  * added include to <boost/scoped_ptr.hpp>; solving #177 <https://github.com/ipa-mdl/ros_canopen/issues/177>
  * default to canopen::SimpleMaster::Allocator (#71 <https://github.com/ipa-mdl/ros_canopen/issues/71>)
  * exit code for generic error should be 1, not -1
  * styled and sorted CMakeLists.txt
    * removed boilerplate comments
    * indention
    * reviewed exported dependencies
  * styled and sorted package.xml
  * update package URLs
  * moved roslib include into source file
  * renamed chain_ros.h to ros_chain.h, fixes #126 <https://github.com/ipa-mdl/ros_canopen/issues/126>
  * Use of catkin_EXPORTED_TARGETS
    Install target for canopen_ros_chain
  * Splitted charn_ros.h into chain_ros.h and ros_chain.cpp
  * Revert "stop heartbeat after stack was shutdown"
    This reverts commit de985b5e9664edbbcc4f743fff3e2a2391e1bf8f.
  * improve failure handling in init service callback
  * improved excetion handling in init and recover callback
  * Merge pull request #109 <https://github.com/ipa-mdl/ros_canopen/issues/109> from ipa-mdl/shutdown-crashes
    Fix for pluginlib-related crashes on shutdown
  * catch std::exception instead of canopen::Exception (#110 <https://github.com/ipa-mdl/ros_canopen/issues/110>)
  * call to detroy is not needed anymore
  * added GuardedClassLoader implementation
  * minor shutdown improvements
  * Contributors: Mathias Lüdtke, Michael Stoll, xaedes

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Fri, 09 Dec 2016 23:00:00 -0000

ros-indigo-canopen-chain-node (0.6.4-0trusty) trusty; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Thu, 02 Jul 2015 22:00:00 -0000

ros-indigo-canopen-chain-node (0.6.3-0trusty) trusty; urgency=high

  * added motor_layer settings
  * remove boost::posix_time::milliseconds from SyncProperties
  * removed support for silence_us since bus timing cannot be guaranteed
  * implemented plugin-based Master allocators, defaults to LocalMaster
  * set initialized to false explicitly if init failed
  * include for std_msgs::String was missing
  * Merge remote-tracking branch 'origin/std_trigger' into new_402
    Conflicts:
    canopen_chain_node/CMakeLists.txt
    canopen_chain_node/include/canopen_chain_node/chain_ros.h
  * halt explicitly on shutdown
  * stop heartbeat after stack was shutdown
  * migrated to Timer instead of ros::Timer to send heartbeat even after ros was shutdown
  * run loop even if ros is shutdown
  * improved chain shutdown behaviour
  * fix for g++: proper message generation
  * Merge branch 'publisher' into muparser
    Conflicts:
    canopen_motor_node/src/control_node.cpp
  * added generic object publishers
  * migrated to std_srvs/Trigger
  * use atomic flag instead of thread pointer for synchronization
  * do not run diagnostics if chain was not initalized, output warning instead
  * Changes Layer Status to Warning during the service calls
  * refactored Layer mechanisms
  * heartbeat works now
  * check XmlRpcValue types in dcf_overlay
  * removed IPCLayer sync listener, loopback is disabled per default
  * added simple heartbeat timer
  * added sync silence feature
  * parse sync properties only if sync_ms is valid
  * require message strings for error indicators, added missing strings, added ROS logging in sync loop
  * skip "eds_pkg" if not provided
  * clear layer before plugin loader is deleted
  * implemented node list as struct
  * 'modules' was renamed to 'nodes'
  * removed chain name
  * added driver_plugin parameter for pluginlib look-up
  * implemented threading in CANLayer
  * removed bitrate, added loopback to DriverInterface::init
  * allow dcf_overlay in defaults as well
  * recursive merge of MergedXmlRpcStruct
  * added dcf_overlay parameter
  * Merge branch 'auto_scale' into indigo_dev
    Conflicts:
    canopen_chain_node/include/canopen_chain_node/chain_ros.h
  * Merge remote-tracking branch 'ipa320/indigo_dev' into indigo_dev
    Conflicts:
    canopen_chain_node/include/canopen_chain_node/chain_ros.h
    canopen_motor_node/src/control_node.cpp
  * catch exceptions during master creation
  * removed MasterType form template
  * added master_type parameter
  * Merge branch 'indigo_dev' into merge
    Conflicts:
    canopen_chain_node/include/canopen_chain_node/chain_ros.h
    canopen_master/include/canopen_master/canopen.h
    canopen_master/include/canopen_master/layer.h
    canopen_master/src/node.cpp
    canopen_motor_node/CMakeLists.txt
    canopen_motor_node/src/control_node.cpp
  * added MergedXmlRpcStruct as replacement for read_xmlrpc_or_praram


=== debian/control ===
Source: ros-indigo-canopen-chain-node
Section: misc
Priority: extra
Maintainer: Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>
Build-Depends: debhelper (>= 9.0.0), ros-indigo-canopen-master, ros-indigo-catkin, ros-indigo-diagnostic-updater, ros-indigo-message-generation, ros-indigo-pluginlib, ros-indigo-roscpp, ros-indigo-roslib, ros-indigo-socketcan-interface, ros-indigo-std-msgs, ros-indigo-std-srvs
Homepage: http://wiki.ros.org/canopen_chain_node
Standards-Version: 3.9.2

Package: ros-indigo-canopen-chain-node
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-indigo-canopen-master, ros-indigo-diagnostic-updater, ros-indigo-message-runtime, ros-indigo-pluginlib, ros-indigo-roscpp, ros-indigo-roslib, ros-indigo-socketcan-interface, ros-indigo-std-msgs, ros-indigo-std-srvs
Description: ROS node base implementation for CANopen chains with support for management services and diagnostics

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/indigo/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/indigo" \
		-DCMAKE_PREFIX_PATH="/opt/ros/indigo"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-indigo-canopen-chain-node//opt/ros/indigo/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_install
